<template>
  <div class="app-container">
    <el-table v-loading="loading" :data="tmToolRequestItemList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="主键id" align="center" prop="toolRequestItemId" />
      <el-table-column label="刀模板申请单id" align="center" prop="toolRequestId" /> -->
      <el-table-column label="物料名称" align="center" prop="itemName" />
      <el-table-column label="总数量" align="center" prop="allQuantity" />
      <el-table-column label="预计使用寿命" align="center" prop="nextMaintenPeriod" />
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改刀模板物料申请单对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="刀模板申请单id" prop="toolRequestId">
          <el-input v-model="form.toolRequestId" placeholder="请输入刀模板申请单id" />
        </el-form-item>
        <el-form-item label="物料id" prop="itemId">
          <el-input v-model="form.itemId" placeholder="请输入物料id" />
        </el-form-item>
        <el-form-item label="总数量" prop="allQuantity">
          <el-input v-model="form.allQuantity" placeholder="请输入总数量" />
        </el-form-item>
        <el-form-item label="预计使用寿命" prop="nextMaintenPeriod">
          <el-input v-model="form.nextMaintenPeriod" placeholder="请输入预计使用寿命" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listTmToolRequestItem, getTmToolRequestItem, delTmToolRequestItem, addTmToolRequestItem, updateTmToolRequestItem } from "@/api/mes/tm/tmToolRequestItem";

export default {
  name: "TmToolRequestItem",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 刀模板物料申请单表格数据
      tmToolRequestItemList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        toolRequestId: null,        itemId: null,        allQuantity: null,        nextMaintenPeriod: null,      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询刀模板物料申请单列表 */
    getList() {
      this.loading = true;
      listTmToolRequestItem(this.queryParams).then(response => {
        this.tmToolRequestItemList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        toolRequestItemId: null,        toolRequestId: null,        itemId: null,        allQuantity: null,        nextMaintenPeriod: null,        createBy: null,        createTime: null,        updateBy: null,        updateTime: null      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.toolRequestItemId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加刀模板物料申请单";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const toolRequestItemId = row.toolRequestItemId || this.ids
      getTmToolRequestItem(toolRequestItemId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改刀模板物料申请单";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.toolRequestItemId != null) {
            updateTmToolRequestItem(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addTmToolRequestItem(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const toolRequestItemIds = row.toolRequestItemId || this.ids;
      this.$modal.confirm('是否确认删除刀模板物料申请单编号为"' + toolRequestItemIds + '"的数据项？').then(function() {
        return delTmToolRequestItem(toolRequestItemIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('tm/tmToolRequestItem/export', {
        ...this.queryParams
      }, `tmToolRequestItem_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
